// Gloabl Variables
var bisProvider; 
var i18nUI;
var logArea;
var root = location.pathname.replace(/\/[^/]+$/, ''); 

function encodeHTMLString (str) {
	return str.replace(/&/g, '&amp;').replace(/"/g, '&quot;').replace(/'/g, '&#039;').replace(/</g, '&lt;').replace(/>/g, '&gt;');
}

function encodeURIComponentXSS(str) {
	if(!str) return str;
	
	return  encodeURIComponent(encodeHTMLString(str));
}

initialize_applicaton();

function initialize_applicaton() {	

	require({ packages: [
	                    { name: 'cognos', location: root + "/js/cognos" },
	        			{ name: "esri2", location: root + "/js/esri"  },
                        { name: 'em4c-bisprovider', location: root + "/../esrimap/em4c-bisprovider" }
	        ]},
			
			["dojo/dom",
	         "dojo/cookie", 
			 "esri2/upgrade/main", 
			 "dojo/i18n!esri2/upgrade/nls/ui",
			 "esri2/upgrade/api/BISPROVIDER", 
			 "cognos/upgrade/BISPROVIDER",
	         "dojo/domReady!"],
	         
	function(dom, cookie, mainPage, i18n, API, CognosProvider){
		
		 
		var cam_passport =  cookie("cam_passport");
		
		if(!cam_passport){
    	  
    	  dom.byId("errorMessage").innerHTML 
    	  	= "Could not find cam_passport! Please log into  <a href='../../'>Cognos</a> first and retrun to this page.";
       
		  dom.byId("appLayout").style.display = "none";
		  dom.byId("loadingOverlay").style.display = "none";
		  dom.byId("errorMessage").style.display = "block";
		  
        }else{
		 
			i18nUI = i18n;
			var implementation = new CognosProvider({campassport: cam_passport}); 
			bisProvider = new API(implementation);	 
			mainPage.load();
		
		}
		
	});
} 

function log (message) {
	 if(logArea==null){
		logArea = dojo.byId("logs");
	 }
	 logArea.innerHTML += message + "<br />";
}